// Joachim Pimiskern, 11.Sept.2011
using System;
using System.Collections.Generic;
using System.Text;
using Fusym;
using System.Diagnostics;

namespace Concepts
{
     public class Concept
    {
        public Node ConceptName;
        public List<SlotValuePair> SlotValuePairs = new List<SlotValuePair>();

        /// <summary>
        /// Tries to find a pair (slotname, slotvalue) by a given slotname.
        /// </summary>
        public SlotValuePair FindSlot(Node slotName)
        {
            int countLeft = SlotValuePairs.Count;

            for (int i = 0; i < countLeft; i++)
            {
                SlotValuePair pairLeft = SlotValuePairs[i];
                Node s = pairLeft.SlotName;
                if (slotName == s)
                    return pairLeft;
            }

            return null;
        }

        public override string ToString()
        {
            if ((SlotValuePairs == null) || (SlotValuePairs.Count == 0))
                return ConceptName.ToString();

            string slots = "";
            int count = SlotValuePairs.Count;
            for (int i = 0; i < count; i++)
            {
                SlotValuePair pair = SlotValuePairs[i];

                Node    slotName  = pair.SlotName;
                Concept slotValue = pair.SlotValue;

                string s_slotName;
                string s_slotValue;

                if (slotName != null)
                    s_slotName = slotName.ToString();
                else
                    s_slotName = "nil";

                if (slotValue != null)
                    s_slotValue = slotValue.ToString();
                else
                    s_slotValue = "";

                if (slotValue != null)
                    slots += " (" + s_slotName + " " + s_slotValue + ")";
                else
                    slots += " " + s_slotName;
            }

            return "(" + ConceptName.ToString() + slots + ")";
        }
    }

    public class SlotValuePair
    {
        public Node    SlotName;
        public Concept SlotValue; // Man knnte sich hier berlegen, beliebige Expressions zuzulassen
    }
}
