// Vielleicht nicht gebraucht
// Joachim Pimiskern, 9.5.2012
using System;
using System.Collections.Generic;
using System.Text;

namespace Fusym
{
    public class SymFndRndBetweenness2
    {
        private SemanticNetwork m_SemanticNetwork;
        private RandomWalk m_RandomWalk;
        private Dictionary<Node, int> m_Dict = new Dictionary<Node, int>();
        private Random m_Rnd = new Random();

        public SymFndRndBetweenness2(SemanticNetwork semanticNetwork)
        {
            m_SemanticNetwork = semanticNetwork;
            m_RandomWalk = new RandomWalk(m_SemanticNetwork);
        }



        //public List<NodeAndMark> Search(string queryString)
        //{
        //    List<Node> path = new List<Node>();
        //    m_Dict.Clear();

        //    List<Node> nodes = ToNodes(queryString);
        //    for (int i = 0; i < 1000; i++)
        //    {
        //        Node n1 = nodes[m_Rnd.Next(nodes.Count)];
        //        Node n2 = nodes[m_Rnd.Next(nodes.Count)];
        //        n1 = ChooseFromNeighborhoodRandomWalk(n1, 5);
        //        n2 = ChooseFromNeighborhoodRandomWalk(n2, 5);

        //        if (m_SemanticNetwork.FindPath(n1, n2, path))
        //            StorePath(path);
        //    }

        //    List<NodeAndMark> result = EvaluateDictionary();

        //    return result;
        //}


        public List<NodeAndMark> Search(string queryString)
        {
            List<Node> path = new List<Node>();
            m_Dict.Clear();

            List<Node> nodes = ToNodes(queryString);



//            List<List<NodeAndMark>> clouds = GetClouds(nodes);
            List<NodeAndMark> cloudOfAll = GetCircleRandomWalkAlpha(nodes, 100000, 5);


            for (int i = 0; i < 1000; i++)
            {
//                List<NodeAndMark> cloud1 = clouds[m_Rnd.Next(clouds.Count)];
//                List<NodeAndMark> cloud2 = clouds[m_Rnd.Next(clouds.Count)];

                List<NodeAndMark> cloud1 = cloudOfAll;
                List<NodeAndMark> cloud2 = cloudOfAll;

                Node n1 = ChooseNode(cloud1);
                Node n2 = ChooseNode(cloud2);

                if ((n1 == null) || (n2 == null))
                    continue;

                if (m_SemanticNetwork.FindPath(n1, n2, path))
                    StorePath(path);
            }

            List<NodeAndMark> result = EvaluateDictionary();

            return result;
        }





        private Node ChooseNode(List<NodeAndMark> nodesAndMarks)
        {
            int sumOfMarks = 0;
            int min = Math.Min(nodesAndMarks.Count,50);

            for (int i = 0; i < min; i++)
                sumOfMarks += nodesAndMarks[i].Mark;


            int r = m_Rnd.Next(sumOfMarks);

            int sum = 0;

            for (int i = 0; i < min; i++)
            {
                {
                    sum += nodesAndMarks[i].Mark;
                    if (sum >= r)
                        return nodesAndMarks[i].Node;
                }
            }

            return null;
        }




        public List<Node> SearchNodes(string queryString)
        {
            List<NodeAndMark> nodesAndMarks = Search(queryString);
            List<Node> result = new List<Node>(nodesAndMarks.Count);

            foreach (NodeAndMark nm in nodesAndMarks)
            {
                nm.Node.Mark = nm.Mark;
                result.Add(nm.Node);
            }

            return result;
        }



        ///---------------------------------------------------------------------
        /// <summary>
        /// Split a string into space-separated substrings
        /// and return the components as Nodes.
        /// </summary>
        ///---------------------------------------------------------------------
        private List<Node> ToNodes(string queryString)
        {
            List<Node> result = new List<Node>();
            List<string> strings = StringUtils.GetQuerySymbols(queryString);
            foreach (string s in strings)
                result.Add(m_SemanticNetwork.AddSymbol(s));
            return result;
        }

        private List<Node> ToNodes(Node n)
        {
            List<Node> result = new List<Node>();
            result.Add(n);
            return result;
        }


        ///---------------------------------------------------------------------
        /// <summary>
        /// Store path in dictionary.
        /// </summary>
        ///---------------------------------------------------------------------
        private void StorePath(List<Node> path)
        {
            int count = path.Count;
            int value;

            foreach (Node n in path)
            {
                if (!m_Dict.TryGetValue(n, out value))
                    value = 0;

                value++;
                m_Dict[n] = value;
            }
        }


        private List<NodeAndMark> EvaluateDictionary()
        {
            List<NodeAndMark> result = new List<NodeAndMark>();

            foreach (KeyValuePair<Node, int> pair in m_Dict)
            {
                NodeAndMark nm = new NodeAndMark();

                nm.Node = pair.Key;
                nm.Mark = pair.Value;
                result.Add(nm);
            }


            result.Sort(NodeAndMark.CmpNodeAndMarkDesc);

            return result;
        }




        ///---------------------------------------------------------------------
        /// Choose a node in the neighborhood.
        ///---------------------------------------------------------------------
        public Node ChooseFromNeighborhoodRandomWalk(Node startNode, int maxDepth)
        {
            m_SemanticNetwork.MarkAllNodes(0);


            int count = 0;
            count++;

            Node n = startNode;
            int depth = 0;

            while (depth <= maxDepth)
            {
                depth++;

                // Choose a random neighbour
                int neighborcount = n.Neighbours.Count;
                if (neighborcount < 1)
                    continue;

                int idx = m_Rnd.Next(neighborcount);
                n = n.Neighbours[idx];
            }

            return n;
        }


        private List<List<NodeAndMark>> GetClouds(List<Node> nodesInput)
        {
            List<List<NodeAndMark>> result = new List<List<NodeAndMark>>();

            foreach (Node n in nodesInput)
            {
                List<NodeAndMark> cloud = GetCircleRandomWalkAlpha(ToNodes(n), 100000, 5);
                result.Add(cloud);
            }

            return result;
        }


        public List<NodeAndMark> GetCircleRandomWalkAlpha(List<Node> nodesInput, int maxCount, int maxDepth)
        {
            List<Node> resultNodes = new List<Node>(m_SemanticNetwork.NodeList.Count);

            m_SemanticNetwork.MarkAllNodes(0);


            foreach (Node startNode in nodesInput)
            {
                int count = 0;
                while (count <= maxCount)
                {
                    count++;

                    Node n = startNode;
                    int depth = 0;

                    while (depth <= maxDepth)
                    {
                        if (n.Mark == 0)
                            resultNodes.Add(n);

                        n.Mark++;
                        depth++;

                        // Choose a random neighbour
                        int neighborcount = n.Neighbours.Count;
                        if (neighborcount < 1)
                            continue;

                        int idx = m_Rnd.Next(neighborcount);
                        n = n.Neighbours[idx];
                    }
                }

            }




//            resultNodes.Sort(SemanticNetwork.cmpMarksDescending);

            List<NodeAndMark> result = NodeAndMark.ToNodeAndMark(resultNodes);
            result.Sort(NodeAndMark.CmpNodeAndMarkDesc);

            return result;
        }


        
    }



    
}
