// 3.11.2010 Joachim Pimiskern
using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace Fusym
{
    public class SympsSearchCustomization : ISearchProgressReceiver
    {
        SemanticNetwork m_SemanticNetwork;
        IDocumentList m_DocumentList;
        ValuedDocList m_ValuedDocList;
        string        m_Query;


        public SympsSearchCustomization(
                                        SemanticNetwork semanticNetwork,
                                        IDocumentList documentlist, 
                                        ValuedDocList valuedDocList,
                                        string query
                                       )
        {
            m_SemanticNetwork = semanticNetwork;
            m_DocumentList    = documentlist;
            m_ValuedDocList   = valuedDocList;
            m_Query           = query.Trim().ToUpper();
        }





        public void Search()
        {
            int maxSym   = 10000;
            int maxDepth = 5;


            //--- DocumentEvaluator ----------------------------------------
            List<string> inputSymbols = StringUtils.GetQuerySymbols(m_Query);

            EvaluationMethod evm = EvaluationMethod.CloudMatching;



            IDocumentEvaluator documentEvaluator = m_SemanticNetwork.NewDocumentEvaluator(
                                                                                          inputSymbols,
                                                                                          maxDepth,
                                                                                          maxSym,
                                                                                          evm,
                                                                                          true
                                                                                        );




            //--------------------------------------------------------------


            SearchManager sm = new SearchManager(
                                                 this,
                                                 m_DocumentList,
                                                 m_ValuedDocList,
                                                 documentEvaluator,
                                                 m_SemanticNetwork
                                                );


            sm.Run();


        }

        public void SetCountOfDocuments(int count)
        {
        }

        public void SetIndexOfDocument(int idx)
        {
        }
    }

}
