// JP, 20.9.2009
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using UnarchControls;
using Fusym;

namespace Unarch5
{
    public partial class FormConnectedComponents : Form
    {
        public FormConnectedComponents()
        {
            InitializeComponent();
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            DoIt();
        }

        private void DoIt()
        {
            GlobalClusterManager gcm = GlobalClusterManager.GetInstance();
            SemanticNetwork cm = gcm.SemanticNetwork;

            string symbol = textBoxStartSymbol.Text;
            symbol = symbol.ToUpper().Trim();


            Betweenness b = new Betweenness();
            List<StringAndCount> list = b.ConnectedComponents(cm, symbol);

            textBoxOutput.Text = "";
            for (int i = 0; i < list.Count; i++)
            {
                StringAndCount sc = list[i];
                textBoxOutput.Text += sc.s + " " + sc.count.ToString() + System.Environment.NewLine;
            }




        }

        private void textBoxStartSymbol_TextChanged(object sender, EventArgs e)
        {
            buttonStart.Enabled = textBoxStartSymbol.Text.Length > 0;
        }
    }
}