// Joachim Pimiskern, 22.9.2010
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Unarch5
{
    public partial class FormEditStringList : Form
    {
        public List<string> Input  = new List<string>(); // To be replaced later.
        public List<string> Output = new List<string>();

        public FormEditStringList()
        {
            InitializeComponent();
        }

        private void Init()
        {
            listBoxActual.Items.Clear();
            for (int i = 0; i < Input.Count; i++)
                listBoxActual.Items.Add(Input[i]);
        }

        private void FormEditStringList_Load(object sender, EventArgs e)
        {
            Bitmap b;

            Init();

            b = (Bitmap)buttonDown.BackgroundImage;
            b.MakeTransparent();

            b = (Bitmap)buttonUp.BackgroundImage;
            b.MakeTransparent();

            b = (Bitmap)buttonDelete.BackgroundImage;
            b.MakeTransparent();

            b = (Bitmap)buttonInsert.BackgroundImage;
            b.MakeTransparent();
        }

        private void buttonUp_Click(object sender, EventArgs e)
        {
            int idx = listBoxActual.SelectedIndex;

            if (idx <= 0)
                return;

            // Swap
            string h = listBoxActual.Items[idx - 1].ToString();
            listBoxActual.Items[idx - 1] = listBoxActual.Items[idx].ToString();
            listBoxActual.Items[idx] = h;

            listBoxActual.SelectedIndex--;
        }

        private void buttonDown_Click(object sender, EventArgs e)
        {
            int idx = listBoxActual.SelectedIndex;

            if (idx < 0)
                return;

            if (idx >= listBoxActual.Items.Count - 1)
                return;

            // Swap
            string h = listBoxActual.Items[idx + 1].ToString();
            listBoxActual.Items[idx + 1] = listBoxActual.Items[idx].ToString();
            listBoxActual.Items[idx] = h;

            listBoxActual.SelectedIndex++;

        }



        ///---------------------------------------------------------------------
        /// <summary>
        /// Transport the selected entry from one to another listbox.
        /// </summary>
        ///---------------------------------------------------------------------
        private void Transport(ListBox l1, ListBox l2)
        {
            int idx = l1.SelectedIndex;

            if (idx < 0)
                return;

            l2.Items.Add(l1.Items[idx]);
            l1.Items.RemoveAt(idx);
            if (idx < l1.Items.Count)
                l1.SelectedIndex = idx;
            else
            if (l1.Items.Count > 0)
                l1.SelectedIndex = l1.Items.Count - 1;
            else
                l1.SelectedIndex = -1;
        }


        private void buttonDelete_Click(object sender, EventArgs e)
        {
            Transport(listBoxActual, listBoxToRemove);
        }

        private void buttonInsert_Click(object sender, EventArgs e)
        {
            Transport(listBoxToRemove, listBoxActual);
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            Output.Clear();
            for (int i = 0; i < listBoxActual.Items.Count; i++)
                Output.Add(listBoxActual.Items[i].ToString());

            Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            Output = Input;
            Close();
        }
    }
}