//------------------------------------------------------------------------------
// Purpose: Options for HTML export
// Date   : 14.Apr.2008
// Author : Joachim Pimiskern
// Status : Freeware
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Unarch5
{
    public partial class FormHtmlOptions : Form
    {
        private HtmlOptions m_Options;


        public FormHtmlOptions(HtmlOptions options)
        {
            InitializeComponent();
            m_Options = options;
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            // DialogResult is set as a button property
            SaveOptions();
            Close();
        }


        private void buttonCancel_Click(object sender, EventArgs e)
        {
            // DialogResult is set as a button property
            Close();
        }

        private void FormHtmlOptions_Shown(object sender, EventArgs e)
        {
            LoadOptions();
        }

        private void SaveOptions()
        {
            m_Options.UseTitle           = checkBoxTitle.Checked;
            m_Options.Title              = textBoxTitle.Text;

            m_Options.UseMetaDescription = checkBoxDescription.Checked;
            m_Options.MetaDescription    = textBoxDescription.Text;

            m_Options.UseMetaKeywords    = checkBoxKeywords.Checked;
            m_Options.MetaKeywords       = textBoxKeywords.Text;

            m_Options.UseMetaLanguage    = checkBoxLanguage.Checked;
            m_Options.MetaLanguage       = textBoxLanguage.Text;

            m_Options.UseMetaRobots      = checkBoxRobots.Checked;
            m_Options.MetaRobots         = textBoxRobots.Text;

            m_Options.UseHeadline        = checkBoxHeadline.Checked;
            m_Options.Headline           = textBoxHeadline.Text;
        }

        private void LoadOptions()
        {
            checkBoxTitle.Checked       = m_Options.UseTitle;
            textBoxTitle.Text           = m_Options.Title;

            checkBoxDescription.Checked = m_Options.UseMetaDescription;
            textBoxDescription.Text     = m_Options.MetaDescription;

            checkBoxKeywords.Checked    = m_Options.UseMetaKeywords;
            textBoxKeywords.Text        = m_Options.MetaKeywords;

            checkBoxLanguage.Checked    = m_Options.UseMetaLanguage;
            textBoxLanguage.Text        = m_Options.MetaLanguage;

            checkBoxRobots.Checked      = m_Options.UseMetaRobots;
            textBoxRobots.Text          = m_Options.MetaRobots;

            checkBoxHeadline.Checked    = m_Options.UseHeadline;
            textBoxHeadline.Text        = m_Options.Headline;
        }
    }
}